/*
   4摜݌v} 04wb_
   2005/ 1/10 ˁ@P
*/
#pragma once
#include <windows.h>

typedef enum {

	pdt4BGR24 = 0x0101,
	pdtBGRX32 = 0x0104,
	pdtBMP    = 0x0180

} PixelDataType;

class IS4DIB;
class IS4DDB;
class IS4DIBSection;

/* rbg}bvC^[tF[X */
class IS4Bitmap {

public:

	/* rbg}bvw肵eɐݒ */
	virtual bool assign(const IS4Bitmap *lpbmpSrc) = 0;
	virtual bool assign(const void * lpData, PixelDataType pdtType) = 0;
	virtual bool assign(const HBITMAP hbmpSrc) = 0;

	/* wTCYERGBlŃrbg}bvNA */
	virtual bool clear(int iWidth, int iHeight, DWORD dwValue) = 0;

	/* t@Cǂݏ */
	virtual bool load(LPCTSTR lpszFilePath) = 0;
	virtual bool save(LPCTSTR lpszFilePath) const = 0;

	/* TCY擾 */
	virtual int getWidth() const = 0;
	virtual int getHeight() const = 0;

	/* sNZRGB擾 */
	virtual DWORD getRGB(int iX, int iY) const = 0;
	virtual DWORD getBGR(int iX, int iY) const = 0;
	virtual DWORD getPixel(int iX, int iY) const = 0;
	virtual BYTE getR(int iX, int iY) const = 0;
	virtual BYTE getG(int iX, int iY) const = 0;
	virtual BYTE getB(int iX, int iY) const = 0;

	/* rbg}bv24rbgDIB`RGBsNZݒ */
	virtual bool set4BGR24(int iX, int iY, int iWidth, int iHeight, const void *lpRGB) = 0;

	/* sNZRGBݒ */
	virtual bool setRGB(int iX, int iY, DWORD dwValue) = 0;
	virtual bool setPixel(int iX, int iY, DWORD dwValue) = 0;
	virtual bool setR(int iX, int iY, int iValue) = 0;
	virtual bool setG(int iX, int iY, int iValue) = 0;
	virtual bool setB(int iX, int iY, int iValue) = 0;

	/* sNZRGBZ */
	virtual bool addR(int iX, int iY, int iValue) = 0;
	virtual bool addG(int iX, int iY, int iValue) = 0;
	virtual bool addB(int iX, int iY, int iValue) = 0;

	/* sNZRGBZ */
	virtual bool mulR(int iX, int iY, double lfValue) = 0;
	virtual bool mulG(int iX, int iY, double lfValue) = 0;
	virtual bool mulB(int iX, int iY, double lfValue) = 0;

	/* J[L[iߐFj擾 */
	virtual DWORD getColorKey() const = 0;

	/* J[L[ݒ */
	virtual bool setColorKey(DWORD dwValue) = 0;

	/* rbg}bvwɕ` */
	virtual bool draw(HDC hdcDst, int iX, int iY) const = 0;
	virtual bool draw(IS4Bitmap *lpbmpDst, int iX, int iY) const = 0;
	virtual bool draw(IS4DIB *lpdibDst, int iX, int iY) const = 0;
	virtual bool draw(IS4DDB *lpddbDst, int iX, int iY) const = 0;
	virtual bool draw(IS4DIBSection *lpdisDst, int iX, int iY) const = 0;

	/* {Iȕ`揈 */
	virtual bool line(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB) = 0;
	virtual bool rect(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB) = 0;
	virtual bool fillRect(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB) = 0;

	// rbg}bv̐؂o
	virtual IS4Bitmap * subBitmap(int iX1, int iY1, int iWidth, int iHeight) = 0;

	/* zfXgN^ */
	virtual ~IS4Bitmap() {}

};

/* DIBC^[tF[X */
class IS4DIB:virtual public IS4Bitmap {

public:

	virtual bool assign(const IS4DIB * pdibSrc) = 0;

	/* BITMAPINFO擾 */
	virtual const BITMAPINFO * getInfo() const = 0;

	/* sNZobt@擾 */
	virtual LPDWORD getScanLine(int iY) = 0;
	virtual const DWORD * getScanLine(int iY) const = 0;

	virtual ~IS4DIB() {}

};

/* DDBC^tF[X */
class IS4DDB:virtual public IS4Bitmap {

public:

	/* rbg}bvnh擾 */
	virtual HBITMAP getHBITMAP() const = 0;

	/* rbg}bvIĂ郁DC擾 */
	virtual HDC getHDC() const = 0;

	virtual ~IS4DDB() {}

};

/* DIBSectionC^[tF[X */
class IS4DIBSection:virtual public IS4DIB, public IS4DDB {

public:

	virtual ~IS4DIBSection() {}

};

class CS4DDB;
class CS4DIBSection;

/* DIBŎꂽrbg}bvNX */
class CS4DIB:virtual public IS4DIB {

public:

	CS4DIB();
	CS4DIB(int iWidth, int iHeight);

	CS4DIB(const IS4Bitmap *lpbmpSrc);
	CS4DIB(const CS4DIB& dibSrc);
	CS4DIB(const CS4DDB& ddbSrc);
	CS4DIB(const CS4DIBSection& disSrc);

	virtual ~CS4DIB();

	CS4DIB& operator=(const CS4DIB& dibSrc);
	CS4DIB& operator=(const CS4DDB& ddbSrc);
	CS4DIB& operator=(const CS4DIBSection& disSrc);

	virtual bool assign(const IS4Bitmap * lpbmpSrc);
	virtual bool assign(const IS4DIB * pdibSrc);
	virtual bool assign(const HBITMAP hbmpSrc);

	virtual bool assign(const void * lpData, PixelDataType pdtType);

	virtual bool setPixels(const void * lpData, PixelDataType pdtType); 

	virtual bool clear(int iWidth, int iHeight, DWORD dwValue = 0x00000000);

	virtual bool load(LPCTSTR lpszFilePath);
	virtual bool save(LPCTSTR lpszFilePath) const;

	virtual int getWidth() const;
	virtual int getHeight() const;

	virtual const BITMAPINFO * getInfo() const;

	virtual DWORD getRGB(int iX, int iY) const;
	virtual DWORD getBGR(int iX, int iY) const;
	virtual DWORD getPixel(int iX, int iY) const;
	virtual BYTE getR(int iX, int iY) const;
	virtual BYTE getG(int iX, int iY) const;
	virtual BYTE getB(int iX, int iY) const;

	virtual bool isColorKey(int iX, int iY) const;

	virtual bool set4BGR24(int iX, int iY, int iWidth, int iHeight, const void *lpRGB);

	virtual bool setRGB(int iX, int iY, DWORD dwValue);
	virtual bool setPixel(int iX, int iY, DWORD dwValue);
	virtual bool setR(int iX, int iY, int iValue);
	virtual bool setG(int iX, int iY, int iValue);
	virtual bool setB(int iX, int iY, int iValue);

	virtual bool addR(int iX, int iY, int iValue);
	virtual bool addG(int iX, int iY, int iValue);
	virtual bool addB(int iX, int iY, int iValue);

	virtual bool mulR(int iX, int iY, double lfValue);
	virtual bool mulG(int iX, int iY, double lfValue);
	virtual bool mulB(int iX, int iY, double lfValue);

	virtual DWORD getColorKey() const;

	virtual bool setColorKey(DWORD dwValue);

	virtual LPDWORD getScanLine(int iY);
	virtual const DWORD * getScanLine(int iY) const;

	virtual bool draw(HDC hdcDst, int iX, int iY) const;
	virtual bool draw(IS4Bitmap *lpbmpDst, int iX, int iY) const;
	virtual bool draw(IS4DIB *lpdibDst, int iX, int iY) const;
	virtual bool draw(IS4DDB *lpddbDst, int iX, int iY) const;
	virtual bool draw(IS4DIBSection *lpdisDst, int iX, int iY) const;

	virtual bool line(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB);
	virtual bool rect(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB);
	virtual bool fillRect(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB);

	virtual IS4Bitmap * subBitmap(int iX1, int iY1, int iX2, int iY2);

private:

	int m_iWidth, m_iHeight;
	DWORD m_dwColorKey;

	BITMAPINFO m_biHeader;
	LPDWORD m_lppxPixels;

};

/* DDBŎꂽrbg}bvNX */
class CS4DDB:virtual public IS4DDB {

public:

	CS4DDB();
	CS4DDB(int iWidth, int iHeight);

	CS4DDB(const IS4Bitmap *lpbmpSrc);
	CS4DDB(const CS4DIB& dibSrc);
	CS4DDB(const CS4DDB& ddbSrc);
	CS4DDB(const CS4DIBSection& disSrc);

	virtual ~CS4DDB();

	CS4DDB& operator=(const CS4DIB& dibSrc);
	CS4DDB& operator=(const CS4DDB& ddbSrc);
	CS4DDB& operator=(const CS4DIBSection& disSrc);

	virtual bool assign(const IS4Bitmap *lpbmpSrc);
	virtual bool assign(const void * lpData, PixelDataType pdtType);
	virtual bool assign(const HBITMAP hbmpSrc);

	virtual bool clear(int iWidth, int iHeight, DWORD dwValue = 0x00000000);

	virtual bool load(LPCTSTR lpszFilePath);
	virtual bool save(LPCTSTR lpszFilePath) const;

	virtual int getWidth() const;
	virtual int getHeight() const;

	virtual DWORD getRGB(int iX, int iY) const;
	virtual DWORD getBGR(int iX, int iY) const;
	virtual DWORD getPixel(int iX, int iY) const;
	virtual BYTE getR(int iX, int iY) const;
	virtual BYTE getG(int iX, int iY) const;
	virtual BYTE getB(int iX, int iY) const;

	virtual bool set4BGR24(int iX, int iY, int iWidth, int iHeight, const void *lpRGB);

	virtual bool setRGB(int iX, int iY, DWORD dwValue);
	virtual bool setPixel(int iX, int iY, DWORD dwValue);
	virtual bool setR(int iX, int iY, int iValue);
	virtual bool setG(int iX, int iY, int iValue);
	virtual bool setB(int iX, int iY, int iValue);

	virtual bool addR(int iX, int iY, int iValue);
	virtual bool addG(int iX, int iY, int iValue);
	virtual bool addB(int iX, int iY, int iValue);

	virtual bool mulR(int iX, int iY, double lfValue);
	virtual bool mulG(int iX, int iY, double lfValue);
	virtual bool mulB(int iX, int iY, double lfValue);

	virtual DWORD getColorKey() const;
	virtual bool isColorKey(int iX, int iY) const;

	virtual bool setColorKey(DWORD dwValue);

	virtual bool draw(HDC hdcDst, int iX, int iY) const;
	virtual bool draw(IS4Bitmap *lpbmpDst, int iX, int iY) const;
	virtual bool draw(IS4DIB *lpdibDst, int iX, int iY) const;
	virtual bool draw(IS4DDB *lpddbDst, int iX, int iY) const;
	virtual bool draw(IS4DIBSection *lpdisDst, int iX, int iY) const;

	virtual bool line(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB);
	virtual bool rect(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB);
	virtual bool fillRect(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB);

	virtual HBITMAP getHBITMAP() const;
	virtual HDC getHDC() const;

	virtual IS4Bitmap * subBitmap(int iX1, int iY1, int iX2, int iY2);

private:

	HBITMAP m_hbmpDDB, m_hbmpOld;
	HDC m_hdcDDB;

	int m_iWidth, m_iHeight;
	DWORD m_dwColorKey;
};

/* DIBSectionŎꂽrbg}bvNX */
class CS4DIBSection:public IS4DIBSection {

public:

	CS4DIBSection();
	CS4DIBSection(int iWidth, int iHeight);

	CS4DIBSection(const IS4Bitmap *lpbmpSrc);
	CS4DIBSection(const CS4DIB& dibSrc);
	CS4DIBSection(const CS4DDB& ddbSrc);
	CS4DIBSection(const CS4DIBSection& disSrc);

	virtual ~CS4DIBSection();

	CS4DIBSection& operator=(const CS4DIB& dibSrc);
	CS4DIBSection& operator=(const CS4DDB& ddbSrc);
	CS4DIBSection& operator=(const CS4DIBSection& disSrc);

	virtual bool assign(const IS4Bitmap *lpbmpSrc);
	virtual bool assign(const IS4DIB * pdibSrc);
	virtual bool assign(const HBITMAP hbmpSrc);

	virtual bool assign(const void * lpData, PixelDataType pdtType);

	virtual bool setPixels(const void * lpData, PixelDataType pdtType); 

	virtual bool clear(int iWidth, int iHeight, DWORD dwValue = 0x00000000);

	virtual bool load(LPCTSTR lpszFilePath);
	virtual bool save(LPCTSTR lpszFilePath) const;

	virtual int getWidth() const;
	virtual int getHeight() const;

	virtual const BITMAPINFO * getInfo() const;
	virtual HDC getHDC();

	virtual DWORD getRGB(int iX, int iY) const;
	virtual DWORD getBGR(int iX, int iY) const;
	virtual DWORD getPixel(int iX, int iY) const;
	virtual BYTE getR(int iX, int iY) const;
	virtual BYTE getG(int iX, int iY) const;
	virtual BYTE getB(int iX, int iY) const;

	virtual bool isColorKey(int iX, int iY) const;

	virtual bool set4BGR24(int iX, int iY, int iWidth, int iHeight, const void *lpRGB);

	virtual bool setRGB(int iX, int iY, DWORD dwValue);
	virtual bool setPixel(int iX, int iY, DWORD dwValue);
	virtual bool setR(int iX, int iY, int iValue);
	virtual bool setG(int iX, int iY, int iValue);
	virtual bool setB(int iX, int iY, int iValue);

	virtual bool addR(int iX, int iY, int iValue);
	virtual bool addG(int iX, int iY, int iValue);
	virtual bool addB(int iX, int iY, int iValue);

	virtual bool mulR(int iX, int iY, double lfValue);
	virtual bool mulG(int iX, int iY, double lfValue);
	virtual bool mulB(int iX, int iY, double lfValue);

	virtual DWORD getColorKey() const;

	virtual bool setColorKey(DWORD dwValue);

	virtual LPDWORD getScanLine(int iY);
	virtual const DWORD * getScanLine(int iY) const;

	virtual bool draw(HDC hdcDst, int iX, int iY) const;
	virtual bool draw(IS4Bitmap *lpbmpDst, int iX, int iY) const;
	virtual bool draw(IS4DIB *lpdibDst, int iX, int iY) const;
	virtual bool draw(IS4DDB *lpddbDst, int iX, int iY) const;
	virtual bool draw(IS4DIBSection *lpdisDst, int iX, int iY) const;

	virtual bool line(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB);
	virtual bool rect(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB);
	virtual bool fillRect(int iX1, int iY1, int iX2, int iY2, DWORD dwRGB);

	virtual IS4Bitmap * subBitmap(int iX1, int iY1, int iX2, int iY2);

	virtual HBITMAP getHBITMAP() const;
	virtual HDC getHDC() const;

private:

	int m_iWidth, m_iHeight;
	DWORD m_dwColorKey;

	HBITMAP m_hbmpBitmap, m_hbmpOld;
	HDC m_hdcBitmap;

	BITMAPINFO m_biHeader;
	LPDWORD m_lppxPixels;

};
